/*
* React Tooltip
* {@link https://github.com/ReactTooltip/react-tooltip}
* @copyright ReactTooltip Team
* @license MIT
*/
import e,{createContext as t,useState as r,useCallback as o,useMemo as n,useContext as l,useRef as c,useEffect as i,useLayoutEffect as s}from"react";import a from"classnames";import{arrow as d,computePosition as u,offset as p,flip as v,shift as m}from"@floating-ui/dom";const y="react-tooltip-core-styles",f="react-tooltip-base-styles",h={core:!1,base:!1};function w({css:e,id:t=f,type:r="base",ref:o}){var n,l;if(!e||"undefined"==typeof document||h[r])return;if("core"===r&&"undefined"!=typeof process&&(null===(n=null===process||void 0===process?void 0:process.env)||void 0===n?void 0:n.REACT_TOOLTIP_DISABLE_CORE_STYLES))return;if("base"!==r&&"undefined"!=typeof process&&(null===(l=null===process||void 0===process?void 0:process.env)||void 0===l?void 0:l.REACT_TOOLTIP_DISABLE_BASE_STYLES))return;"core"===r&&(t=y),o||(o={});const{insertAt:c}=o;if(document.getElementById(t))return void console.warn(`[react-tooltip] Element with id '${t}' already exists. Call \`removeStyle()\` first`);const i=document.head||document.getElementsByTagName("head")[0],s=document.createElement("style");s.id=t,s.type="text/css","top"===c&&i.firstChild?i.insertBefore(s,i.firstChild):i.appendChild(s),s.styleSheet?s.styleSheet.cssText=e:s.appendChild(document.createTextNode(e)),h[r]=!0}function b({type:e="base",id:t=f}={}){if(!h[e])return;"core"===e&&(t=y);const r=document.getElementById(t);"style"===(null==r?void 0:r.tagName)?null==r||r.remove():console.warn(`[react-tooltip] Failed to remove 'style' element with id '${t}'. Call \`injectStyle()\` first`),h[e]=!1}const S=(e,t,r)=>{let o=null;return function(...n){const l=()=>{o=null,r||e.apply(this,n)};r&&!o&&(e.apply(this,n),o=setTimeout(l,t)),r||(o&&clearTimeout(o),o=setTimeout(l,t))}},E="DEFAULT_TOOLTIP_ID",g={anchorRefs:new Set,activeAnchor:{current:null},attach:()=>{},detach:()=>{},setActiveAnchor:()=>{}},_=t({getTooltipData:()=>g}),A=({children:t})=>{const[l,c]=r({[E]:new Set}),[i,s]=r({[E]:{current:null}}),a=(e,...t)=>{c((r=>{var o;const n=null!==(o=r[e])&&void 0!==o?o:new Set;return t.forEach((e=>n.add(e))),{...r,[e]:new Set(n)}}))},d=(e,...t)=>{c((r=>{const o=r[e];return o?(t.forEach((e=>o.delete(e))),{...r}):r}))},u=o(((e=E)=>{var t,r;return{anchorRefs:null!==(t=l[e])&&void 0!==t?t:new Set,activeAnchor:null!==(r=i[e])&&void 0!==r?r:{current:null},attach:(...t)=>a(e,...t),detach:(...t)=>d(e,...t),setActiveAnchor:t=>((e,t)=>{s((r=>{var o;return(null===(o=r[e])||void 0===o?void 0:o.current)===t.current?r:{...r,[e]:t}}))})(e,t)}}),[l,i,a,d]),p=n((()=>({getTooltipData:u})),[u]);return e.createElement(_.Provider,{value:p},t)};function T(e=E){return l(_).getTooltipData(e)}const L=({tooltipId:t,children:r,className:o,place:n,content:l,html:s,variant:d,offset:u,wrapper:p,events:v,positionStrategy:m,delayShow:y,delayHide:f})=>{const{attach:h,detach:w}=T(t),b=c(null);return i((()=>(h(b),()=>{w(b)})),[]),e.createElement("span",{ref:b,className:a("react-tooltip-wrapper",o),"data-tooltip-place":n,"data-tooltip-content":l,"data-tooltip-html":s,"data-tooltip-variant":d,"data-tooltip-offset":u,"data-tooltip-wrapper":p,"data-tooltip-events":v,"data-tooltip-position-strategy":m,"data-tooltip-delay-show":y,"data-tooltip-delay-hide":f},r)},O="undefined"!=typeof window?s:i,R=e=>{if(!(e instanceof HTMLElement||e instanceof SVGElement))return!1;const t=getComputedStyle(e);return["overflow","overflow-x","overflow-y"].some((e=>{const r=t.getPropertyValue(e);return"auto"===r||"scroll"===r}))},N=e=>{if(!e)return null;let t=e.parentElement;for(;t;){if(R(t))return t;t=t.parentElement}return document.scrollingElement||document.documentElement},x=async({elementReference:e=null,tooltipReference:t=null,tooltipArrowReference:r=null,place:o="top",offset:n=10,strategy:l="absolute",middlewares:c=[p(Number(n)),v(),m({padding:5})],border:i})=>{if(!e)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};if(null===t)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};const s=c;return r?(s.push(d({element:r,padding:5})),u(e,t,{placement:o,strategy:l,middleware:s}).then((({x:e,y:t,placement:r,middlewareData:o})=>{var n,l;const c={left:`${e}px`,top:`${t}px`,border:i},{x:s,y:a}=null!==(n=o.arrow)&&void 0!==n?n:{x:0,y:0},d=null!==(l={top:"bottom",right:"left",bottom:"top",left:"right"}[r.split("-")[0]])&&void 0!==l?l:"bottom",u=i&&{top:{borderBottom:i,borderRight:i},right:{borderBottom:i,borderLeft:i},bottom:{borderTop:i,borderLeft:i},left:{borderTop:i,borderRight:i}}[r.split("-")[0]];let p=0;if(i){const e=`${i}`.match(/(\d+)px/);p=(null==e?void 0:e[1])?Number(e[1]):1}return{tooltipStyles:c,tooltipArrowStyles:{left:null!=s?`${s}px`:"",top:null!=a?`${a}px`:"",right:"",bottom:"",...u,[d]:`-${4+p}px`},place:r}}))):u(e,t,{placement:"bottom",strategy:l,middleware:s}).then((({x:e,y:t,placement:r})=>({tooltipStyles:{left:`${e}px`,top:`${t}px`},tooltipArrowStyles:{},place:r})))};var k="core-styles-module_tooltip__3vRRp",$="core-styles-module_fixed__pcSol",C="core-styles-module_arrow__cvMwQ",I="core-styles-module_noArrow__xock6",B="core-styles-module_clickable__ZuTTB",j="core-styles-module_show__Nt9eE",D={tooltip:"styles-module_tooltip__mnnfp",arrow:"styles-module_arrow__K0L3T",dark:"styles-module_dark__xNqje",light:"styles-module_light__Z6W-X",success:"styles-module_success__A2AKt",warning:"styles-module_warning__SCK0X",error:"styles-module_error__JvumD",info:"styles-module_info__BWdHW"};const H=({id:t,className:o,classNameArrow:n,variant:l="dark",anchorId:s,anchorSelect:d,place:u="top",offset:p=10,events:v=["hover"],openOnClick:m=!1,positionStrategy:y="absolute",middlewares:f,wrapper:h,delayShow:w=0,delayHide:b=0,float:E=!1,hidden:g=!1,noArrow:_=!1,clickable:A=!1,closeOnEsc:L=!1,closeOnScroll:R=!1,closeOnResize:H=!1,style:q,position:z,afterShow:W,afterHide:M,content:P,contentWrapperRef:F,isOpen:K,setIsOpen:U,activeAnchor:X,setActiveAnchor:Y,border:V,opacity:Z})=>{const G=c(null),J=c(null),Q=c(null),ee=c(null),[te,re]=r(u),[oe,ne]=r({}),[le,ce]=r({}),[ie,se]=r(!1),[ae,de]=r(!1),ue=c(!1),pe=c(null),{anchorRefs:ve,setActiveAnchor:me}=T(t),ye=c(!1),[fe,he]=r([]),we=c(!1),be=m||v.includes("click");O((()=>(we.current=!0,()=>{we.current=!1})),[]),i((()=>{if(!ie){const e=setTimeout((()=>{de(!1)}),150);return()=>{clearTimeout(e)}}return()=>null}),[ie]);const Se=e=>{we.current&&(e&&de(!0),setTimeout((()=>{we.current&&(null==U||U(e),void 0===K&&se(e))}),10))};i((()=>{if(void 0===K)return()=>null;K&&de(!0);const e=setTimeout((()=>{se(K)}),10);return()=>{clearTimeout(e)}}),[K]),i((()=>{ie!==ue.current&&(ue.current=ie,ie?null==W||W():null==M||M())}),[ie]);const Ee=(e=b)=>{ee.current&&clearTimeout(ee.current),ee.current=setTimeout((()=>{ye.current||Se(!1)}),e)},ge=e=>{var t;if(!e)return;const r=null!==(t=e.currentTarget)&&void 0!==t?t:e.target;if(!(null==r?void 0:r.isConnected))return Y(null),void me({current:null});w?(Q.current&&clearTimeout(Q.current),Q.current=setTimeout((()=>{Se(!0)}),w)):Se(!0),Y(r),me({current:r}),ee.current&&clearTimeout(ee.current)},_e=()=>{A?Ee(b||100):b?Ee():Se(!1),Q.current&&clearTimeout(Q.current)},Ae=({x:e,y:t})=>{x({place:u,offset:p,elementReference:{getBoundingClientRect:()=>({x:e,y:t,width:0,height:0,top:t,left:e,right:e,bottom:t})},tooltipReference:G.current,tooltipArrowReference:J.current,strategy:y,middlewares:f,border:V}).then((e=>{Object.keys(e.tooltipStyles).length&&ne(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&ce(e.tooltipArrowStyles),re(e.place)}))},Te=e=>{if(!e)return;const t=e,r={x:t.clientX,y:t.clientY};Ae(r),pe.current=r},Le=e=>{ge(e),b&&Ee()},Oe=e=>{var t;[document.querySelector(`[id='${s}']`),...fe].some((t=>null==t?void 0:t.contains(e.target)))||(null===(t=G.current)||void 0===t?void 0:t.contains(e.target))||(Se(!1),Q.current&&clearTimeout(Q.current))},Re=S(ge,50,!0),Ne=S(_e,50,!0);i((()=>{var e,t;const r=new Set(ve);fe.forEach((e=>{r.add({current:e})}));const o=document.querySelector(`[id='${s}']`);o&&r.add({current:o});const n=()=>{Se(!1)},l=N(X),c=N(G.current);R&&(window.addEventListener("scroll",n),null==l||l.addEventListener("scroll",n),null==c||c.addEventListener("scroll",n)),H&&window.addEventListener("resize",n);const i=e=>{"Escape"===e.key&&Se(!1)};L&&window.addEventListener("keydown",i);const a=[];be?(window.addEventListener("click",Oe),a.push({event:"click",listener:Le})):(a.push({event:"mouseenter",listener:Re},{event:"mouseleave",listener:Ne},{event:"focus",listener:Re},{event:"blur",listener:Ne}),E&&a.push({event:"mousemove",listener:Te}));const d=()=>{ye.current=!0},u=()=>{ye.current=!1,_e()};return A&&!be&&(null===(e=G.current)||void 0===e||e.addEventListener("mouseenter",d),null===(t=G.current)||void 0===t||t.addEventListener("mouseleave",u)),a.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.addEventListener(e,t)}))})),()=>{var e,t;R&&(window.removeEventListener("scroll",n),null==l||l.removeEventListener("scroll",n),null==c||c.removeEventListener("scroll",n)),H&&window.removeEventListener("resize",n),be&&window.removeEventListener("click",Oe),L&&window.removeEventListener("keydown",i),A&&!be&&(null===(e=G.current)||void 0===e||e.removeEventListener("mouseenter",d),null===(t=G.current)||void 0===t||t.removeEventListener("mouseleave",u)),a.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.removeEventListener(e,t)}))}))}}),[ae,ve,fe,L,v]),i((()=>{let e=null!=d?d:"";!e&&t&&(e=`[data-tooltip-id='${t}']`);const r=new MutationObserver((r=>{const o=[];r.forEach((r=>{if("attributes"===r.type&&"data-tooltip-id"===r.attributeName){r.target.getAttribute("data-tooltip-id")===t&&o.push(r.target)}if("childList"===r.type&&(X&&[...r.removedNodes].some((e=>{var t;return!!(null===(t=null==e?void 0:e.contains)||void 0===t?void 0:t.call(e,X))&&(de(!1),Se(!1),Y(null),Q.current&&clearTimeout(Q.current),ee.current&&clearTimeout(ee.current),!0)})),e))try{const t=[...r.addedNodes].filter((e=>1===e.nodeType));o.push(...t.filter((t=>t.matches(e)))),o.push(...t.flatMap((t=>[...t.querySelectorAll(e)])))}catch(e){}})),o.length&&he((e=>[...e,...o]))}));return r.observe(document.body,{childList:!0,subtree:!0,attributes:!0,attributeFilter:["data-tooltip-id"]}),()=>{r.disconnect()}}),[t,d,X]);const xe=()=>{z?Ae(z):E?pe.current&&Ae(pe.current):x({place:u,offset:p,elementReference:X,tooltipReference:G.current,tooltipArrowReference:J.current,strategy:y,middlewares:f,border:V}).then((e=>{we.current&&(Object.keys(e.tooltipStyles).length&&ne(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&ce(e.tooltipArrowStyles),re(e.place))}))};i((()=>{xe()}),[ie,X,P,q,u,p,y,z]),i((()=>{if(!(null==F?void 0:F.current))return()=>null;const e=new ResizeObserver((()=>{xe()}));return e.observe(F.current),()=>{e.disconnect()}}),[P,null==F?void 0:F.current]),i((()=>{var e;const t=document.querySelector(`[id='${s}']`),r=[...fe,t];X&&r.includes(X)||Y(null!==(e=fe[0])&&void 0!==e?e:t)}),[s,fe,X]),i((()=>()=>{Q.current&&clearTimeout(Q.current),ee.current&&clearTimeout(ee.current)}),[]),i((()=>{let e=d;if(!e&&t&&(e=`[data-tooltip-id='${t}']`),e)try{const t=Array.from(document.querySelectorAll(e));he(t)}catch(e){he([])}}),[t,d]);const ke=!g&&P&&ie&&Object.keys(oe).length>0;return ae?e.createElement(h,{id:t,role:"tooltip",className:a("react-tooltip",k,D.tooltip,D[l],o,`react-tooltip__place-${te}`,{[j]:ke,[$]:"fixed"===y,[B]:A}),style:{...q,...oe,opacity:void 0!==Z&&ke?Z:void 0},ref:G},P,e.createElement(h,{className:a("react-tooltip-arrow",C,D.arrow,n,{[I]:_}),style:le,ref:J})):null},q=({content:t})=>e.createElement("span",{dangerouslySetInnerHTML:{__html:t}}),z=({id:t,anchorId:o,anchorSelect:n,content:l,html:s,render:a,className:d,classNameArrow:u,variant:p="dark",place:v="top",offset:m=10,wrapper:y="div",children:f=null,events:h=["hover"],openOnClick:w=!1,positionStrategy:b="absolute",middlewares:S,delayShow:E=0,delayHide:g=0,float:_=!1,hidden:A=!1,noArrow:L=!1,clickable:O=!1,closeOnEsc:R=!1,closeOnScroll:N=!1,closeOnResize:x=!1,style:k,position:$,isOpen:C,disableStyleInjection:I=!1,border:B,opacity:j,setIsOpen:D,afterShow:z,afterHide:W})=>{const[M,P]=r(l),[F,K]=r(s),[U,X]=r(v),[Y,V]=r(p),[Z,G]=r(m),[J,Q]=r(E),[ee,te]=r(g),[re,oe]=r(_),[ne,le]=r(A),[ce,ie]=r(y),[se,ae]=r(h),[de,ue]=r(b),[pe,ve]=r(null),me=c(I),{anchorRefs:ye,activeAnchor:fe}=T(t),he=e=>null==e?void 0:e.getAttributeNames().reduce(((t,r)=>{var o;if(r.startsWith("data-tooltip-")){t[r.replace(/^data-tooltip-/,"")]=null!==(o=null==e?void 0:e.getAttribute(r))&&void 0!==o?o:null}return t}),{}),we=e=>{const t={place:e=>{var t;X(null!==(t=e)&&void 0!==t?t:v)},content:e=>{P(null!=e?e:l)},html:e=>{K(null!=e?e:s)},variant:e=>{var t;V(null!==(t=e)&&void 0!==t?t:p)},offset:e=>{G(null===e?m:Number(e))},wrapper:e=>{var t;ie(null!==(t=e)&&void 0!==t?t:y)},events:e=>{const t=null==e?void 0:e.split(" ");ae(null!=t?t:h)},"position-strategy":e=>{var t;ue(null!==(t=e)&&void 0!==t?t:b)},"delay-show":e=>{Q(null===e?E:Number(e))},"delay-hide":e=>{te(null===e?g:Number(e))},float:e=>{oe(null===e?_:"true"===e)},hidden:e=>{le(null===e?A:"true"===e)}};Object.values(t).forEach((e=>e(null))),Object.entries(e).forEach((([e,r])=>{var o;null===(o=t[e])||void 0===o||o.call(t,r)}))};i((()=>{P(l)}),[l]),i((()=>{K(s)}),[s]),i((()=>{X(v)}),[v]),i((()=>{V(p)}),[p]),i((()=>{G(m)}),[m]),i((()=>{Q(E)}),[E]),i((()=>{te(g)}),[g]),i((()=>{oe(_)}),[_]),i((()=>{le(A)}),[A]),i((()=>{ue(b)}),[b]),i((()=>{me.current!==I&&console.warn("[react-tooltip] Do not change `disableStyleInjection` dynamically.")}),[I]),i((()=>{"undefined"!=typeof window&&window.dispatchEvent(new CustomEvent("react-tooltip-inject-styles",{detail:{disableCore:"core"===I,disableBase:I}}))}),[]),i((()=>{var e;const r=new Set(ye);let l=n;if(!l&&t&&(l=`[data-tooltip-id='${t}']`),l)try{document.querySelectorAll(l).forEach((e=>{r.add({current:e})}))}catch(e){console.warn(`[react-tooltip] "${l}" is not a valid CSS selector`)}const c=document.querySelector(`[id='${o}']`);if(c&&r.add({current:c}),!r.size)return()=>null;const i=null!==(e=null!=pe?pe:c)&&void 0!==e?e:fe.current,s=new MutationObserver((e=>{e.forEach((e=>{var t;if(!i||"attributes"!==e.type||!(null===(t=e.attributeName)||void 0===t?void 0:t.startsWith("data-tooltip-")))return;const r=he(i);we(r)}))})),a={attributes:!0,childList:!1,subtree:!1};if(i){const e=he(i);we(e),s.observe(i,a)}return()=>{s.disconnect()}}),[ye,fe,pe,o,n]),i((()=>{(null==k?void 0:k.border)&&console.warn("[react-tooltip] Do not set `style.border`. Use `border` prop instead."),B&&!CSS.supports("border",`${B}`)&&console.warn(`[react-tooltip] "${B}" is not a valid \`border\`.`),(null==k?void 0:k.opacity)&&console.warn("[react-tooltip] Do not set `style.opacity`. Use `opacity` prop instead."),j&&!CSS.supports("opacity",`${j}`)&&console.warn(`[react-tooltip] "${j}" is not a valid \`opacity\`.`)}),[]);let be=f;const Se=c(null);if(a){const t=a({content:null!=M?M:null,activeAnchor:pe});be=t?e.createElement("div",{ref:Se,className:"react-tooltip-content-wrapper"},t):null}else M&&(be=M);F&&(be=e.createElement(q,{content:F}));const Ee={id:t,anchorId:o,anchorSelect:n,className:d,classNameArrow:u,content:be,contentWrapperRef:Se,place:U,variant:Y,offset:Z,wrapper:ce,events:se,openOnClick:w,positionStrategy:de,middlewares:S,delayShow:J,delayHide:ee,float:re,hidden:ne,noArrow:L,clickable:O,closeOnEsc:R,closeOnScroll:N,closeOnResize:x,style:k,position:$,isOpen:C,border:B,opacity:j,setIsOpen:D,afterShow:z,afterHide:W,activeAnchor:pe,setActiveAnchor:e=>ve(e)};return e.createElement(H,{...Ee})};"undefined"!=typeof window&&window.addEventListener("react-tooltip-inject-styles",(e=>{e.detail.disableCore||w({css:`:root{--rt-color-white:#fff;--rt-color-dark:#222;--rt-color-success:#8dc572;--rt-color-error:#be6464;--rt-color-warning:#f0ad4e;--rt-color-info:#337ab7;--rt-opacity:0.9}.core-styles-module_tooltip__3vRRp{visibility:hidden;position:absolute;top:0;left:0;pointer-events:none;opacity:0;transition:opacity 0.3s ease-out;will-change:opacity,visibility}.core-styles-module_fixed__pcSol{position:fixed}.core-styles-module_arrow__cvMwQ{position:absolute;background:inherit}.core-styles-module_noArrow__xock6{display:none}.core-styles-module_clickable__ZuTTB{pointer-events:auto}.core-styles-module_show__Nt9eE{visibility:visible;opacity:var(--rt-opacity)}`,type:"core"}),e.detail.disableBase||w({css:`
.styles-module_tooltip__mnnfp{padding:8px 16px;border-radius:3px;font-size:90%;width:max-content}.styles-module_arrow__K0L3T{width:8px;height:8px;transform:rotate(45deg)}.styles-module_dark__xNqje{background:var(--rt-color-dark);color:var(--rt-color-white)}.styles-module_light__Z6W-X{background-color:var(--rt-color-white);color:var(--rt-color-dark)}.styles-module_success__A2AKt{background-color:var(--rt-color-success);color:var(--rt-color-white)}.styles-module_warning__SCK0X{background-color:var(--rt-color-warning);color:var(--rt-color-white)}.styles-module_error__JvumD{background-color:var(--rt-color-error);color:var(--rt-color-white)}.styles-module_info__BWdHW{background-color:var(--rt-color-info);color:var(--rt-color-white)}`,type:"base"})}));export{z as Tooltip,A as TooltipProvider,L as TooltipWrapper,b as removeStyle};
